import { reactive as _e, computed as N, defineComponent as Fe, ref as g, withAsyncContext as ve, onMounted as Oe, resolveComponent as H, unref as l, openBlock as W, createBlock as z, withCtx as E, createCommentVNode as G, createElementVNode as ke, createVNode as I, isRef as De, createElementBlock as we, Fragment as Te, createTextVNode as oe } from "vue";
import { G as Se } from "./index-1041b100.mjs";
import { G as xe } from "./index-ae7f6b10.mjs";
import { f as S } from "./index-ac2a962f.mjs";
import { f as Ce } from "./index-b079b3f0.mjs";
import { compact as Ae, keyBy as L, cloneDeep as le } from "lodash";
import { message as F, Modal as Re } from "ant-design-vue";
import { a as qe } from "./Xhttp-85cb516e.mjs";
import { _ as Ee } from "./_commonjsHelpers-4c55c438.mjs";
const Ne = async (r) => r ? await Ce.queryFormDesign(r) : void 0, He = (r, n) => {
  if (!r)
    return !1;
  let s = r.substring(r.lastIndexOf(".") + 1, r.length);
  return s = s.toLocaleLowerCase(), n.includes(s);
}, B = (r, n) => {
  const s = r.map((i) => typeof i == "string" ? n.find(({ key: c }) => c == i) : i);
  return Ae(s);
}, We = (r, n) => {
  const s = {}, i = {}, c = {};
  let a = [];
  if (r.length != 0) {
    r.forEach((o) => {
      s[o[1]] = o[2], i[o[1]] = o;
    });
    for (let o = 0; o < n.length; o++) {
      const { field: y } = n[o].renderer.options;
      s[y] && (c[y] = s[y], delete s[y]);
    }
    a = Object.keys(s).map((o) => i[o]);
  }
  return {
    defaultFields: c,
    regularFilter: a
  };
}, U = [
  {
    key: "add",
    label: "添加",
    icon: "PlusOutlined"
  },
  {
    key: "download",
    label: "导出",
    icon: "DownloadOutlined"
  },
  {
    key: "import",
    label: "导入",
    icon: "ImportOutlined"
  },
  {
    key: "deletes",
    label: "批量删除",
    icon: "DeleteOutlined"
  }
], V = [
  {
    key: "edit",
    label: "编辑"
  },
  {
    key: "readonly",
    label: "查看"
  },
  {
    key: "delete",
    label: "删除",
    color: "#f00",
    confirm: !0
  }
], Ge = async (r, n) => {
  var R;
  const s = ((R = n == null ? void 0 : n.query) == null ? void 0 : R.form) || r.formName, i = _e({
    formDef: {},
    formRecordData: {},
    readonly: !1
  }), c = await Ne(s);
  if (r.customDicts) {
    const d = {
      ...L(c.dicts, "name"),
      ...L(r.customDicts, "name")
    };
    c.dicts = Object.values(d);
  }
  i.formDef = c;
  const { tableOptions: a } = r, { table: o, dicts: y } = c, x = N(() => {
    let d = U;
    return a != null && a.tableOperators ? d = B(a.tableOperators, U) : o != null && o.tableOperators && (d = B(x, U)), d;
  }), C = N(() => {
    let d = V;
    return a != null && a.recordOperators ? d = B(a.recordOperators, V) : o != null && o.recordOperators && (d = B(C, V)), d;
  }), u = {
    searchFields: [],
    tableFields: [],
    outFields: [],
    groups: {}
  };
  if (typeof r.formTableOptionsHandler == "function") {
    const d = await r.formTableOptionsHandler(o), { tableFields: p, outFields: O, searchItems: f, groups: h } = d || {};
    u.searchFields = f || [], u.tableFields = p || [], u.outFields = O || [], u.groups = h || {};
  } else {
    let { tableFields: d, outFields: p, searchItems: O, groups: f } = o || {};
    a != null && a.searchItems && (O = a.searchItems), a != null && a.tableFields && (d = a.tableFields), a != null && a.outFields && (p = a.outFields), a != null && a.groups && (f = a.groups), u.searchFields = O || [], u.tableFields = d || [], u.outFields = p || [], u.groups = f || {};
  }
  const { defaultFields: A, regularFilter: w } = We(
    r.initFilter || [],
    u.searchFields
  ), v = (a == null ? void 0 : a.modalWidth) || (o == null ? void 0 : o.modalWidth) || "90%";
  return {
    formName: s,
    formOptions: i,
    dicts: y,
    recordOperators: C,
    tableOperators: x,
    ...u,
    defaultFields: A,
    regularFilter: w,
    modalWidth: v
  };
}, $ = "_mis_sub_items", se = function(r) {
  const n = {};
  return Object.keys(r).forEach((s) => {
    s == $ ? r[$].forEach((i) => {
      n[i.form] = {
        form: i.form,
        data: i.data.map((c) => se(c))
      };
    }) : n[s] = r[s];
  }), n;
}, P = function(r) {
  if (!r)
    return;
  const n = {}, s = [];
  return Object.keys(r).forEach((i) => {
    const c = r[i];
    Ie(c) ? (c.data = c.data.map((a) => P(a)), s.push(c)) : n[i] = c;
  }), s.length > 0 && (n[$] = s), n;
};
function Ie(r) {
  return r && typeof r == "object" && !Array.isArray(r) && r.form && r.data && Array.isArray(r.data);
}
const Be = /* @__PURE__ */ Fe({
  name: "GTSearchTable",
  __name: "index",
  props: {
    tableOptions: { type: Object, required: !1 },
    formName: { type: String, required: !1 },
    showTitle: { type: Boolean, required: !1, default: !0 },
    yOffset: { type: Number, required: !1, default: 310 },
    searchListWidth: { type: Number, required: !1, default: 300 },
    operatorWidth: { type: Number, required: !1 },
    allowSelect: { type: Boolean, required: !1, default: !0 },
    customDicts: { type: Array, required: !1 },
    formTableOptionsHandler: { type: Function, required: !1 },
    beforeTableData: { type: Function, required: !1 },
    beforeSubmitHandler: { type: Function, required: !1 },
    beforeErrorMsg: { type: Function, required: !1 },
    initFilter: { type: Array, required: !1 }
  },
  emits: ["search-change", "operate"],
  async setup(r, { expose: n, emit: s }) {
    let i, c;
    const a = qe(), o = r, y = s, x = g(), C = g(), u = g(), A = g(!1), w = g(!1), v = g(!1), R = g(0), d = g(0), p = g(""), O = g([]), f = g({
      page: {
        pageNum: 1,
        pageSize: 10
      },
      resolveSubItems: !0
    });
    n({ getList: T, tableData: O });
    const {
      formOptions: h,
      dicts: Y,
      searchFields: M,
      tableFields: K,
      groups: ne,
      recordOperators: Q,
      tableOperators: J,
      outFields: j,
      defaultFields: ie,
      regularFilter: X,
      formName: k,
      modalWidth: ce
    } = ([i, c] = ve(() => Ge(o, a)), i = await i, c(), i), Z = N(() => o.showTitle ? h.formDef.title : ""), de = N(() => Z.value ? o.yOffset + 50 + d.value : o.yOffset + d.value), ee = N(() => {
      const t = {
        ...L(Q.value, "key"),
        ...L(J.value, "key")
      };
      return p.value ? t[p.value].label + "数据" : "查看数据";
    }), fe = (t) => {
      d.value = t;
    }, ue = async (t) => {
      try {
        const e = t.target.files[0];
        if (!He(e.name, ["xls", "xlsx", "xlsm"])) {
          F.warning("只能导入Excel表格！");
          return;
        }
        await S.importFormData(k, e), F.success("导入成功！"), T();
      } catch (e) {
        F.error(e.msg);
      }
      t.target.value = "";
    }, me = (t) => {
      let { field: e, order: m } = t;
      if (e && m) {
        let _ = { field: e, direction: m };
        f.value.orders = [_];
      } else
        delete f.value.orders;
      T();
    }, pe = ({ key: t, data: e }) => {
      switch (t) {
        case "edit":
        case "readonly":
          te(t, e);
          break;
        case "delete":
          re([e._id]);
          break;
        default:
          y("operate", { key: t, data: e });
          break;
      }
    }, ge = ({ key: t, data: e }) => {
      if (t)
        switch (t) {
          case "add":
            te(t);
            break;
          case "download":
            be(e);
            break;
          case "import":
            u.value.click();
            break;
          case "deletes":
            ye(e);
            break;
          default:
            y("operate", { key: t, data: e });
            break;
        }
    }, te = (t, e = {}) => {
      const m = e ? le(e) : "";
      h.formRecordData = se(m), p.value = t, h.readonly = t === "readonly", v.value = !0;
    }, ye = (t) => {
      t.length == 0 ? F.warning("请选择要删除的数据！") : Re.confirm({
        title: "信息",
        content: "是否确定删除已选择的数据？",
        onOk() {
          re(t);
        },
        onCancel() {
        }
      });
    }, re = async (t) => {
      try {
        await S.bathDeleteFormData(k, t), T();
      } catch (e) {
        console.log("error :>> ", e), F.error(e.msg);
      }
    }, be = (t) => {
      let e = {};
      t.length == 0 ? (e = le(f.value), delete e.page) : e = {
        filter: ["in", "_id", t]
      }, Array.isArray(j) && j.length != 0 && (e.outFields = j), e.resolveDic = !1, S.dataDownload(
        `${h.formDef.title || k}-填报数据.xlsx`,
        k,
        e
      );
    }, ae = (t) => {
      let e = [];
      t.map(({ name: m, value: _, operator: D }) => {
        let q = [];
        switch (D) {
          case "like":
            q = [D, m, `%${_}%`];
            break;
          default:
            q = [D, m, _];
            break;
        }
        e.push(q);
      }), X.length != 0 && e.push(...X), e.length > 1 ? e.unshift("and") : e = e.flat(1), f.value.filter = e, f.value.page.pageNum = 1, T();
    }, he = async () => {
      w.value = !0;
      const t = await C.value.submit();
      if (t.state) {
        let e = t.data;
        if (typeof o.beforeSubmitHandler == "function" && (e = await o.beforeSubmitHandler(e, p.value)), typeof e > "u") {
          w.value = !1;
          return;
        }
        try {
          p.value == "add" ? await S.addFormData(k, P(e)) : (e._id = h.formRecordData._id, await S.updateFormData(k, P(e))), F.success(`${ee.value}成功！`), await T(), v.value = !1;
        } catch ({ msg: m, data: _, code: D }) {
          if (typeof o.beforeErrorMsg == "function")
            o.beforeErrorMsg({ msg: m, data: _, code: D });
          else
            switch (D) {
              case 4011:
                F.error(`${_.fields}不能重复！`);
                break;
              default:
                F.error(m);
                break;
            }
        } finally {
          w.value = !1;
        }
      } else
        w.value = !1;
    };
    async function T() {
      if (k)
        try {
          A.value = !0;
          let t = await S.searchFormData(k, f.value);
          typeof o.beforeTableData == "function" && (t = await o.beforeTableData(t)), R.value = t.total, O.value = t.list;
        } catch (t) {
          F.error(t.msg);
        } finally {
          A.value = !1;
        }
    }
    return Oe(() => {
      M.length !== 0 ? x.value.submitHandler() : ae([]);
    }), (t, e) => {
      const m = H("a-button"), _ = H("GTForm"), D = H("a-modal"), q = H("a-card");
      return l(h).formDef ? (W(), z(q, {
        key: 0,
        class: "card-max",
        title: l(Z)
      }, {
        default: E(() => [
          l(M).length != 0 ? (W(), z(Se, {
            key: 0,
            ref_key: "search_box",
            ref: x,
            listWidth: t.searchListWidth,
            fields: l(M),
            onSearch: ae,
            onChange: e[0] || (e[0] = (b) => y("search-change", b)),
            defaultFields: l(ie),
            dicts: l(Y),
            onAddHeight: fe
          }, null, 8, ["listWidth", "fields", "defaultFields", "dicts"])) : G("", !0),
          ke("input", {
            type: "file",
            ref_key: "import_file",
            ref: u,
            onInput: e[1] || (e[1] = (b) => ue(b)),
            accept: "application/vnd.ms-excel,application/vnd.openxmlformats-officedocument.spreadsheetml.sheet",
            style: { display: "none" }
          }, null, 544),
          l(K).length != 0 ? (W(), z(xe, {
            key: 1,
            fields: l(K),
            data: l(O),
            recordOperators: l(Q),
            tableOperators: l(J),
            onTableOperatorClick: ge,
            onRecordOperatorClick: pe,
            pageCurrent: l(f).page.pageNum,
            "onUpdate:pageCurrent": e[2] || (e[2] = (b) => l(f).page.pageNum = b),
            pageSize: l(f).page.pageSize,
            "onUpdate:pageSize": e[3] || (e[3] = (b) => l(f).page.pageSize = b),
            total: l(R),
            dicts: l(Y),
            groups: l(ne),
            allowSelect: t.allowSelect,
            keyField: "_id",
            yOffset: l(de),
            loading: l(A),
            operatorWidth: t.operatorWidth,
            onRefresh: me
          }, null, 8, ["fields", "data", "recordOperators", "tableOperators", "pageCurrent", "pageSize", "total", "dicts", "groups", "allowSelect", "yOffset", "loading", "operatorWidth"])) : G("", !0),
          I(D, {
            open: l(v),
            "onUpdate:open": e[5] || (e[5] = (b) => De(v) ? v.value = b : null),
            title: l(ee),
            maskClosable: !1,
            destroyOnClose: "",
            width: l(ce),
            getContainer: ".card-max",
            class: "form-modal-box"
          }, {
            footer: E(() => [
              l(p) !== "readonly" ? (W(), we(Te, { key: 0 }, [
                I(m, {
                  key: "back",
                  onClick: e[4] || (e[4] = (b) => v.value = !1)
                }, {
                  default: E(() => [
                    oe("取消")
                  ]),
                  _: 1
                }),
                I(m, {
                  key: "submit",
                  type: "primary",
                  loading: l(w),
                  onClick: he
                }, {
                  default: E(() => [
                    oe("确认")
                  ]),
                  _: 1
                }, 8, ["loading"])
              ], 64)) : G("", !0)
            ]),
            default: E(() => [
              I(_, {
                ref_key: "gt_form",
                ref: C,
                options: l(h)
              }, null, 8, ["options"])
            ]),
            _: 1
          }, 8, ["open", "title", "width"])
        ]),
        _: 1
      }, 8, ["title"])) : G("", !0);
    };
  }
});
const Le = /* @__PURE__ */ Ee(Be, [["__scopeId", "data-v-fa470cbf"], ["__file", "/Users/qiweicun/Desktop/vscode/mis-component-vue3/src/components/GTSearchTable/index.vue"]]), Qe = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  default: Le
}, Symbol.toStringTag, { value: "Module" }));
export {
  Le as G,
  Qe as _
};
