import { defineComponent as g, ref as c, onMounted as h, openBlock as b, createElementBlock as w, createVNode as x, unref as l } from "vue";
import { R as I } from "./index-4746ada0.mjs";
import { e as i } from "./Workspace-5be60936.mjs";
import { x as L, d as k } from "./Xhttp-85cb516e.mjs";
import { message as r } from "ant-design-vue";
import { _ as A } from "./_commonjsHelpers-4c55c438.mjs";
const q = {
  // 查询资源列表
  async queryResourceList(n) {
    return await L.get(
      k.RESOURCE_LIST,
      n
    );
  }
}, C = { class: "authorApi-box" }, D = /* @__PURE__ */ g({
  __name: "index",
  props: {
    currentRoleItem: { type: Object, required: !0 }
  },
  setup(n) {
    let _ = c(0), o = c(!1);
    const u = c([]), s = c([]), d = n, p = [
      {
        title: "接口名称",
        dataIndex: "name"
      },
      {
        title: "接口地址",
        dataIndex: "uri"
      },
      {
        title: "所属分组",
        dataIndex: "groupname"
      },
      {
        title: "接口描述",
        dataIndex: "description"
      }
    ], m = async () => {
      o.value = !0;
      try {
        const e = await q.queryResourceList({ type: "api" });
        u.value = e.list;
      } catch ({ msg: e }) {
        r.error(e);
      } finally {
        o.value = !1;
      }
    }, f = async () => {
      const { _id: e } = d.currentRoleItem;
      try {
        let t = await i.authResource(e, { type: "api" });
        s.value = t.map((a) => a._id);
      } catch {
        r.error("获取角色授权接口失败");
      }
    };
    h(async () => {
      await m(), await f();
    });
    const R = async (e, t) => {
      const { _id: a } = d.currentRoleItem;
      t ? await v(a, e) : await y(a, e);
    }, v = async (e, t) => {
      o.value = !0;
      try {
        await i.authorizeResource(e, t), r.success("授权成功"), s.value.push(...t);
      } catch ({ msg: a }) {
        r.error(a);
      } finally {
        o.value = !1;
      }
    }, y = async (e, t) => {
      o.value = !0;
      try {
        await i.revokeResource(e, t), r.success("取消授权成功"), s.value = s.value.filter((a) => !t.includes(a));
      } catch ({ msg: a }) {
        r.error(a);
      } finally {
        o.value = !1;
      }
    };
    return (e, t) => (b(), w("div", C, [
      x(I, {
        currentRoleItem: e.currentRoleItem,
        columns: p,
        tableData: l(u),
        tableLoading: l(o),
        onRowClick: R,
        total: l(_),
        selectedRowKeysFlag: l(s),
        pagination: !1,
        scrollY: 240
      }, null, 8, ["currentRoleItem", "tableData", "tableLoading", "total", "selectedRowKeysFlag"])
    ]));
  }
});
const E = /* @__PURE__ */ A(D, [["__scopeId", "data-v-dc34cf93"], ["__file", "/Users/qiweicun/Desktop/vscode/mis-component-vue3/src/views/RoleManage/Permission/components/AuthorApi/index.vue"]]), F = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  default: E
}, Symbol.toStringTag, { value: "Module" }));
export {
  E as A,
  F as _
};
