import { defineComponent as B, ref as l, readonly as S, reactive as T, resolveComponent as _, openBlock as G, createElementBlock as K, createElementVNode as c, createVNode as o, unref as s, withCtx as r, createTextVNode as g, toDisplayString as Z, isRef as H, normalizeStyle as J, nextTick as M, pushScopeId as W, popScopeId as Q } from "vue";
import { S as X } from "./types-b6ebfd92.mjs";
import { s as O } from "./index-aa0f9070.mjs";
import { message as y } from "ant-design-vue";
import { l as Y } from "./index-54c61fa6.mjs";
import { _ as ee } from "./_commonjsHelpers-4c55c438.mjs";
const N = (C) => (W("data-v-7c9942ec"), C = C(), Q(), C), oe = { class: "login-wrapper" }, se = /* @__PURE__ */ N(() => /* @__PURE__ */ c("div", { class: "title" }, "重置密码", -1)), te = { class: "body" }, re = { class: "submit" }, ae = { class: "link-wrapper" }, ie = { class: "img-verify-code-content" }, le = /* @__PURE__ */ N(() => /* @__PURE__ */ c("h3", null, "请输入验证码", -1)), ne = { class: "img-wrapper" }, de = 180, ce = /* @__PURE__ */ B({
  __name: "index",
  emits: ["update:status"],
  setup(C, { emit: U }) {
    const D = U, b = l(!1), a = l({
      phone: "",
      verifyCode: "",
      password: "",
      confirmPassword: ""
    }), q = S({
      phone: [
        {
          trigger: "blur",
          required: !0,
          message: "请输入手机号码"
        },
        {
          trigger: "blur",
          pattern: /^1(3[0-9]|4[5,7]|5[0,1,2,3,5,6,7,8,9]|6[2,5,6,7]|7[0,1,2,3,5,6,7,8]|8[0-9]|9[1,5,8,9])\d{8}$/,
          message: "请输入正确的手机号码"
        }
      ],
      verifyCode: [
        {
          trigger: "blur",
          required: !0,
          message: "请输入验证码"
        }
      ],
      password: [
        {
          trigger: "blur",
          required: !0,
          message: "请输入密码"
        },
        {
          trigger: "blur",
          pattern: /^.*(?=.{6,16})(?=.*\d)(?=.*[A-Z])(?=.*[a-z]).*$/,
          message: "密码6到16位，包含数字和大小写字母"
        }
      ],
      confirmPassword: [
        {
          trigger: "blur",
          required: !0,
          message: "请输再次输入密码"
        },
        {
          trigger: "blur",
          pattern: /^.*(?=.{6,16})(?=.*\d)(?=.*[A-Z])(?=.*[a-z]).*$/,
          message: "密码6到16位，包含数字和大小写字母"
        },
        {
          trigger: "blur",
          validator: async (t, e) => e !== a.value.password ? Promise.reject("两次输入的密码不一致") : Promise.resolve()
        }
      ]
    }), h = l(), x = l(), w = l(), k = l(!1), m = l(!1), I = l(""), P = l(""), p = T({
      loading: !1,
      verifyCodeDisabled: !1,
      modelVisible: !1,
      getVerifyCodeText: "获取验证码"
    }), v = T({
      imgVerifyCode: ""
    }), A = S({
      imgVerifyCode: [
        {
          required: !0,
          message: "请输入验证码"
        }
      ]
    }), V = async () => {
      const t = await O.getImageCode();
      t && (I.value = t.imgKey, P.value = t.base64);
    }, $ = () => {
      m.value = !1;
    }, F = () => {
      var t;
      (t = h.value) == null || t.validateFields("phone").then(async () => {
        m.value = !0, V(), M(() => {
          var e;
          (e = w.value) == null || e.focus();
        });
      });
    }, L = () => {
      var t;
      (t = x.value) == null || t.validateFields().then(
        async () => {
          var e;
          k.value = !0;
          try {
            await O.getResetPasswdSmsCode(
              a.value.phone,
              I.value,
              v.imgVerifyCode
            ), y.success("短信验证码已发送"), m.value = !1, z();
          } catch (n) {
            y.error(`验证码错误：${n.msg || "未知错误"}`), V(), v.imgVerifyCode = "", (e = w.value) == null || e.focus();
          } finally {
            k.value = !1;
          }
        },
        (e) => {
          y.error(JSON.stringify(e));
        }
      );
    }, z = () => {
      v.imgVerifyCode = "", p.verifyCodeDisabled = !0;
      let t = de;
      const e = setInterval(() => {
        p.getVerifyCodeText = `${t}秒后重新获取`, t -= 1, t === 0 && (p.getVerifyCodeText = "获取验证码", p.verifyCodeDisabled = !1, clearInterval(e));
      }, 1e3);
    }, j = () => {
      var t;
      (t = h.value) == null || t.validate().then(async (e) => {
        b.value = !0;
        const { phone: n, verifyCode: u, password: f } = e;
        try {
          if (!await Y.resetPassword(n, u, f))
            return;
          y.success("重置密码成功"), a.value = {
            phone: "",
            verifyCode: "",
            password: "",
            confirmPassword: ""
          };
        } catch (d) {
          y.error(d.msg);
        } finally {
          b.value = !1;
        }
      });
    };
    return (t, e) => {
      const n = _("svg-icon"), u = _("a-input"), f = _("a-form-item"), d = _("a-button"), R = _("a-form"), E = _("a-modal");
      return G(), K("div", oe, [
        se,
        c("div", te, [
          o(R, {
            model: s(a),
            ref_key: "resetPwdRef",
            ref: h,
            rules: s(q)
          }, {
            default: r(() => [
              o(f, { name: "phone" }, {
                default: r(() => [
                  o(u, {
                    value: s(a).phone,
                    "onUpdate:value": e[0] || (e[0] = (i) => s(a).phone = i),
                    class: "input-item",
                    allowClear: "",
                    placeholder: "手机号码"
                  }, {
                    prefix: r(() => [
                      o(n, { icon: "PhoneOutlined" })
                    ]),
                    _: 1
                  }, 8, ["value"])
                ]),
                _: 1
              }),
              o(f, { name: "verifyCode" }, {
                default: r(() => [
                  o(u, {
                    ref_key: "verifyInputRef",
                    ref: w,
                    value: s(a).verifyCode,
                    "onUpdate:value": e[1] || (e[1] = (i) => s(a).verifyCode = i),
                    class: "input-item verify-code",
                    placeholder: "验证码"
                  }, {
                    prefix: r(() => [
                      o(n, { icon: "NumberOutlined" })
                    ]),
                    _: 1
                  }, 8, ["value"]),
                  o(d, {
                    class: "btn-verify-code",
                    type: "link",
                    onClick: F,
                    disabled: s(p).verifyCodeDisabled
                  }, {
                    default: r(() => [
                      g(Z(s(p).getVerifyCodeText), 1)
                    ]),
                    _: 1
                  }, 8, ["disabled"])
                ]),
                _: 1
              }),
              o(f, { name: "password" }, {
                default: r(() => [
                  o(u, {
                    value: s(a).password,
                    "onUpdate:value": e[2] || (e[2] = (i) => s(a).password = i),
                    type: "password",
                    allowClear: "",
                    class: "input-item",
                    placeholder: "密码6到16位，包含数字和大小写字母"
                  }, {
                    prefix: r(() => [
                      o(n, { icon: "LockOutlined" })
                    ]),
                    _: 1
                  }, 8, ["value"])
                ]),
                _: 1
              }),
              o(f, { name: "confirmPassword" }, {
                default: r(() => [
                  o(u, {
                    type: "password",
                    value: s(a).confirmPassword,
                    "onUpdate:value": e[3] || (e[3] = (i) => s(a).confirmPassword = i),
                    class: "input-item",
                    allowClear: "",
                    placeholder: "确认密码"
                  }, {
                    prefix: r(() => [
                      o(n, { icon: "LockOutlined" })
                    ]),
                    _: 1
                  }, 8, ["value"])
                ]),
                _: 1
              }),
              c("div", re, [
                o(d, {
                  type: "primary",
                  block: "",
                  onClick: j,
                  class: "input-item",
                  loading: s(b)
                }, {
                  default: r(() => [
                    g(" 确定 ")
                  ]),
                  _: 1
                }, 8, ["loading"])
              ]),
              c("div", ae, [
                o(d, {
                  class: "btn-forget-passwd",
                  type: "link",
                  onClick: e[4] || (e[4] = () => D("update:status", s(X).SIGNING))
                }, {
                  default: r(() => [
                    g("立即登录")
                  ]),
                  _: 1
                })
              ])
            ]),
            _: 1
          }, 8, ["model", "rules"]),
          o(E, {
            class: "img-verify-code-wrapper",
            open: s(m),
            "onUpdate:open": e[6] || (e[6] = (i) => H(m) ? m.value = i : null),
            footer: null,
            onCancel: $
          }, {
            default: r(() => [
              c("div", ie, [
                le,
                c("div", ne, [
                  c("img", {
                    class: "img-verify-code",
                    style: J({ "background-image": `url(${s(P)})` })
                  }, null, 4),
                  o(d, {
                    class: "btn-change-code",
                    type: "link",
                    onClick: V
                  }, {
                    default: r(() => [
                      g("看不清，换一个")
                    ]),
                    _: 1
                  })
                ]),
                o(R, {
                  ref_key: "codeFormRef",
                  ref: x,
                  model: s(v),
                  rules: s(A)
                }, {
                  default: r(() => [
                    o(f, {
                      class: "input-img-code",
                      name: "imgVerifyCode"
                    }, {
                      default: r(() => [
                        o(u, {
                          ref_key: "verifyInputRef",
                          ref: w,
                          value: s(v).imgVerifyCode,
                          "onUpdate:value": e[5] || (e[5] = (i) => s(v).imgVerifyCode = i),
                          maxLength: 4,
                          allowClear: !0,
                          placeholder: "验证码"
                        }, null, 8, ["value"])
                      ]),
                      _: 1
                    }),
                    o(d, {
                      type: "primary",
                      block: "",
                      onClick: L,
                      class: "input-item",
                      loading: s(k)
                    }, {
                      default: r(() => [
                        g(" 确定 ")
                      ]),
                      _: 1
                    }, 8, ["loading"])
                  ]),
                  _: 1
                }, 8, ["model", "rules"])
              ])
            ]),
            _: 1
          }, 8, ["open"])
        ])
      ]);
    };
  }
});
const ue = /* @__PURE__ */ ee(ce, [["__scopeId", "data-v-7c9942ec"], ["__file", "/Users/qiweicun/Desktop/vscode/mis-component-vue3/src/views/Login/components/ResetPasswd/index.vue"]]), Ce = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  default: ue
}, Symbol.toStringTag, { value: "Module" }));
export {
  ue as R,
  Ce as _
};
