import { defineComponent as b, ref as l, onMounted as R, openBlock as x, createElementBlock as h, createVNode as E, unref as u } from "vue";
import { R as q } from "./index-4746ada0.mjs";
import { x as c, M as i } from "./Xhttp-85cb516e.mjs";
import { e as _ } from "./Workspace-5be60936.mjs";
import { message as r } from "ant-design-vue";
import { _ as T } from "./_commonjsHelpers-4c55c438.mjs";
const D = {
  // 查询菜单树
  // TODO 后台接口问题，不传 {} 会报错
  async queryMenuTree() {
    return await c.get(i.TREE_LIST, {});
  },
  // 添加新菜单
  async addMenu(n) {
    return await c.post(i.ADD_MENU, n);
  },
  async deleteMenu(n) {
    return await c.delete(i.DELETE_MENU(n));
  },
  async modifyMenu(n) {
    return await c.put(i.UPDATE_MENU(n._id), n);
  }
}, k = { class: "menu-box" }, I = /* @__PURE__ */ b({
  __name: "index",
  props: {
    currentRoleItem: { type: Object, required: !0 }
  },
  setup(n) {
    let d = l(0), o = l(!1);
    const m = l([]), s = l([]), p = n, f = [
      {
        title: "名称",
        dataIndex: "name"
      },
      {
        title: "路径",
        dataIndex: "uri"
      },
      {
        title: "组件",
        dataIndex: "component"
      }
    ], y = async () => {
      o.value = !0;
      try {
        const e = await D.queryMenuTree();
        m.value = e, d.value = e.length;
      } catch ({ msg: e }) {
        r.error(e);
      } finally {
        o.value = !1;
      }
    }, v = async () => {
      const { _id: e } = p.currentRoleItem, t = await _.queryAuthorizeMenus(e);
      s.value = t.map((a) => a._id);
    };
    R(async () => {
      await y(), await v();
    });
    const M = async (e, t) => {
      const { _id: a } = p.currentRoleItem;
      t ? await g(a, e) : await w(a, e);
    }, g = async (e, t) => {
      o.value = !0;
      try {
        await _.authorizeMenu(e, t), r.success("授权成功"), s.value.push(...t);
      } catch ({ msg: a }) {
        r.error(a);
      } finally {
        o.value = !1;
      }
    }, w = async (e, t) => {
      o.value = !0;
      try {
        await _.revokeMenu(e, t), r.success("取消授权成功"), s.value = s.value.filter((a) => !t.includes(a));
      } catch ({ msg: a }) {
        r.error(a);
      } finally {
        o.value = !1;
      }
    };
    return (e, t) => (x(), h("div", k, [
      E(q, {
        columns: f,
        tableData: u(m),
        tableLoading: u(o),
        onRowClick: M,
        total: u(d),
        selectedRowKeysFlag: u(s),
        pagination: !1,
        scrollY: 240
      }, null, 8, ["tableData", "tableLoading", "total", "selectedRowKeysFlag"])
    ]));
  }
});
const U = /* @__PURE__ */ T(I, [["__scopeId", "data-v-5976b1f1"], ["__file", "/Users/qiweicun/Desktop/vscode/mis-component-vue3/src/views/RoleManage/Permission/components/Menu/index.vue"]]), F = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  default: U
}, Symbol.toStringTag, { value: "Module" }));
export {
  U as M,
  F as _,
  D as m
};
