import { defineComponent as P, mergeModels as $, useModel as W, ref as w, onMounted as z, resolveComponent as D, openBlock as T, createElementBlock as N, createElementVNode as E, createVNode as m, unref as R, createBlock as G, withCtx as F, createTextVNode as h } from "vue";
import { message as b } from "ant-design-vue";
import { cloneDeep as S } from "lodash";
import { f as U } from "./index-b079b3f0.mjs";
import { _ as Y } from "./_commonjsHelpers-4c55c438.mjs";
let H = (e) => crypto.getRandomValues(new Uint8Array(e)), Q = (e, t, r) => {
  let i = (2 << Math.log(e.length - 1) / Math.LN2) - 1, o = -~(1.6 * i * t / e.length);
  return (a = t) => {
    let d = "";
    for (; ; ) {
      let n = r(o), s = o;
      for (; s--; )
        if (d += e[n[s] & i] || "", d.length === a)
          return d;
    }
  };
}, B = (e, t = 21) => Q(e, t, H), J = !1, q = "", A = [], k = [];
const C = () => B("abcdefghijklmnopqrstuvwxyz", 1)() + B("abcdefghijklmnopqrstuvwxyz1234567890", 9)(), I = {
  LonLatField: [
    "lonField",
    "latField",
    "pcodeField",
    "ccodeField",
    "fcodeField",
    "pnameField",
    "cnameField",
    "fnameField",
    "addressField"
  ],
  NumberWithUnitField: ["valueField", "unitField"],
  DateRangeField: ["startField", "endField"],
  AdminField: ["field", "subField"]
};
function M(e, t, r) {
  var i;
  if (Array.isArray(e))
    e.forEach((o) => {
      M(o, t, r);
    });
  else {
    const o = (i = e == null ? void 0 : e.options) == null ? void 0 : i.children;
    Array.isArray(o) ? o.forEach((a) => {
      r && a.children ? a.children.forEach((d) => {
        L(d, t, r);
      }) : L(a, t, r);
    }) : L(e, t, r);
  }
}
function L(e, t, r) {
  var i, o, a;
  if ((i = e == null ? void 0 : e.type) != null && i.endsWith("Field")) {
    const d = K(e, t);
    r ? d.forEach(({ field: n, label: s }) => {
      A.includes(n) || k.push(s);
    }) : (Z(d, t), j(d, t), J && ie(d, t)), O(d, t);
  } else
    (o = e == null ? void 0 : e.type) != null && o.endsWith("SubForm") ? X(e, t, r) : (a = e == null ? void 0 : e.options) != null && a.children && M(e, t, r);
}
function X(e, t, r) {
  const { options: i } = e;
  i.field || (i.field = C());
  const o = [
    {
      name: i.field,
      formUid: i.formUid,
      depends: i.depends,
      required: i.required,
      label: i.label,
      sorted_field: i.sorted_field
    }
  ];
  O(o, t, !0), r || ee(o, t);
}
function K(e, t, r = !1) {
  const i = [], { type: o } = e, a = r ? e : e.options, d = S(a);
  return I[o] && !r ? I[o].forEach((n) => {
    var s;
    if (typeof a[n] == "object") {
      (s = a[n]) != null && s.field || (a[n].field = C());
      const u = S(a[n]);
      u.depends = a.depends, i.push(...K(u, t, !0));
    }
  }) : (d.name = a.field = a.field || C(), i.push(d)), i;
}
function Z(e, t) {
  e.forEach((r) => {
    const { label: i, type: o, name: a, unique: d, spareLabel: n } = r, s = t.fields.findIndex((p) => p.name == a), u = {
      //如果有依赖则为空
      // required: !depends && required,
      required: !1,
      unique: d,
      label: i,
      // 设置的导入导出Excel label
      spareLabel: n,
      type: o,
      name: a
    };
    s == -1 ? t.fields.push(u) : t.fields.splice(s, 1, u);
  });
}
function j(e, t) {
  e.forEach((r) => {
    r.dictRef && (t.dictRefs[r.name] = r.dictRef);
  });
}
function O(e, t, r = !1) {
  e.forEach((o) => {
    i(o, t, r);
  });
  function i(o, a, d) {
    const { name: n, depends: s, required: u, label: p } = o, v = d ? "subform" : "field", _ = d ? "subformValidators" : "fieldValidators", c = a.validators[_] || [];
    if (!u)
      a.validators[_] = c.filter((l) => Array.isArray(l.validators) ? l[v] === n ? (l.validators = l.validators.filter(
        ({ type: f }) => f !== "required"
      ), l.validators.length != 0) : !0 : !1);
    else {
      const l = c.find((f) => f[v] === n);
      if (l)
        s && (l.depends = s), p && (l.label = p), Array.isArray(l.validators) ? l.validators.some((x) => x.type === "required") || l.validators.push({ type: "required" }) : l.validators = [{ type: "required" }];
      else {
        const f = { label: p };
        f[v] = n, (s || u) && (s && (f.depends = s), u && (f.validators = [{ type: "required" }]), c.push(f));
      }
    }
  }
}
function ee(e, t) {
  e.forEach(({ formUid: r, sorted_field: i }) => {
    const o = {
      name: r,
      fk: "__main_form_record_uid_field__"
    };
    i && (o.sorted_field = i), t.subTables.push(o);
  });
}
function te(e, t) {
  if (t) {
    e.validators || (e.validators = {}), e.validators.fieldValidators || (e.validators.fieldValidators = []), e.validators.subformValidators || (e.validators.subformValidators = []), delete e.validators.subFormValidators;
    return;
  }
  Array.isArray(e.fields) || (e.fields = []), e.subTables = [], e.dictRefs = {}, e.validators || (e.validators = {}), e.validators.fieldValidators || (e.validators.fieldValidators = []), e.validators.subformValidators || (e.validators.subformValidators = []), e.table || (e.table = {}), Array.isArray(e.table.tableFields) || (e.table.tableFields = []), delete e.validators.subFormValidators, J = e.table.tableFields.length == 0;
}
function ie(e, t) {
  e.forEach((r) => {
    const { label: i, name: o, type: a } = r;
    t.table.tableFields.push({
      label: i,
      name: o,
      type: a,
      width: 100
    });
  });
}
function g(e, t) {
  if (t || le(e), !e.layout)
    return e;
  te(e, t);
  let r = e.layout;
  return e.layout.children && (r = e.layout.children), M(r, e, t), t || (q == "web" && (e.profile_web = {
    layout: e.layout,
    validators: e.validators
  }), e.profile_mobile && (A = e.fields.map((i) => i.name), g(e.profile_mobile, "app"), k.length > 0 && b.info(
    `app配置字段中 ${k.join(",")} 无法在数据库字段中找到，请修改配置！`
  ), A = [], k = [], q = "")), e;
}
function le(e) {
  e.profile_web && e.profile_mobile || e.profile_web ? (e.layout = e.profile_web.layout, e.validators = e.profile_web.validators, q = "web") : q = "";
}
const re = { class: "max" }, ae = { class: "content-box" }, oe = {
  key: 1,
  class: "form-box"
}, de = { class: "footer-box" }, se = /* @__PURE__ */ P({
  name: "FormDesignEditor",
  __name: "index",
  props: /* @__PURE__ */ $({
    type: { type: String, required: !0 },
    data: { type: null, required: !0 }
  }, {
    open: {},
    openModifiers: {}
  }),
  emits: /* @__PURE__ */ $(["getList"], ["update:open"]),
  setup(e, { emit: t }) {
    const r = W(e, "open"), i = e, o = t, a = w(), d = w(), n = w(!1);
    let s = "";
    const u = w({
      formDef: {}
    });
    z(() => {
      i.type === "add" ? (a.value.setValue({
        name: "",
        title: "",
        description: "",
        dicts: [],
        layout: [],
        fields: [],
        table: {
          searchItems: [
            {
              operator: "=",
              renderer: {
                type: "TextField",
                options: {
                  field: "test",
                  label: "搜索条件"
                }
              }
            }
          ],
          tableFields: [
            {
              label: "_id",
              name: "_id"
            }
          ]
        }
      }), s = "") : (a.value.setValue(i.data), s = i.data.name);
    });
    async function p() {
      const c = a.value.getValue();
      if (!c.state) {
        b.warning("请输入正确的json格式表单！");
        return;
      }
      const l = g(c.data);
      if (!l.name) {
        b.warning("表单name不能为空！");
        return;
      }
      try {
        s ? await U.updateFormDesign(s, l) : await U.addFormDesign(l), b.success(`${s ? "编辑" : "添加"}成功！`), r.value = !1, o("getList");
      } catch (f) {
        b.error(f.msg);
      }
    }
    function v(c) {
      if (!c) {
        const l = a.value.getValue();
        if (!l.state) {
          b.warning("请输入正确的json格式表单！");
          return;
        }
        u.value.formDef = g(l.data);
      }
      n.value = !c;
    }
    function _(c = !1) {
      const l = a.value.getValue();
      if (!l.state) {
        b.warning("请输入正确的json格式表单！");
        return;
      }
      c ? a.value.setValue(g(l.data)) : d.value.setValue(g(l.data));
    }
    return (c, l) => {
      const f = D("AceEditor"), x = D("GTForm"), y = D("a-button");
      return T(), N("div", re, [
        E("div", ae, [
          m(f, {
            class: "ace-editor",
            onBindKey: l[0] || (l[0] = (V) => _()),
            ref_key: "editor1",
            ref: a
          }, null, 512),
          R(n) ? (T(), N("div", oe, [
            m(x, { options: R(u) }, null, 8, ["options"])
          ])) : (T(), G(f, {
            key: 0,
            class: "ace-editor",
            ref_key: "editor2",
            ref: d,
            theme: "monokai",
            readonly: ""
          }, null, 512))
        ]),
        E("div", de, [
          E("div", null, [
            m(y, {
              type: "primary",
              onClick: l[1] || (l[1] = (V) => _())
            }, {
              default: F(() => [
                h("点击验证")
              ]),
              _: 1
            }),
            m(y, {
              type: "primary",
              onClick: l[2] || (l[2] = (V) => v(R(n)))
            }, {
              default: F(() => [
                h("切换视图")
              ]),
              _: 1
            }),
            m(y, {
              type: "primary",
              onClick: l[3] || (l[3] = (V) => _(!0))
            }, {
              default: F(() => [
                h("格式化")
              ]),
              _: 1
            })
          ]),
          E("div", null, [
            m(y, {
              onClick: l[4] || (l[4] = (V) => r.value = !1)
            }, {
              default: F(() => [
                h("取消")
              ]),
              _: 1
            }),
            m(y, {
              type: "primary",
              onClick: p
            }, {
              default: F(() => [
                h("确定")
              ]),
              _: 1
            })
          ])
        ])
      ]);
    };
  }
});
const ne = /* @__PURE__ */ Y(se, [["__scopeId", "data-v-d6c0e998"], ["__file", "/Users/qiweicun/Desktop/vscode/mis-component-vue3/src/views/FormDesign/components/FormDesignEditor/index.vue"]]), be = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  default: ne
}, Symbol.toStringTag, { value: "Module" }));
export {
  ne as F,
  be as _,
  B as c
};
