import { x as e, e as a } from "./Xhttp-85cb516e.mjs";
import { F as o } from "./index-ac2a962f.mjs";
import { message as n } from "ant-design-vue";
const p = {
  /**
   * 表单定义文件详情
   * @param {*} formId 表单id
   * @returns
   */
  async queryFormDesign(r) {
    return (await e.get(a.QUERY(r))).table_content;
  },
  /**
   * 表单定义文件查询
   * @param {*} params 查询参数
   * @returns
   */
  async searchFormDesign(r) {
    return await e.get(a.SEARCH, r);
  },
  /**
   * 表单定义文件添加
   * @param {*} json json数据
   * @returns
   */
  async addFormDesign(r) {
    return await e.post(a.DEPLOY, r);
  },
  /**
   * 表单定义文件更新
   * @param {*} formId 表单id
   * @param {*} json json数据
   * @returns
   */
  async updateFormDesign(r, t) {
    return await e.put(a.UPDATE(r), t);
  },
  /**
   * 删除表单定义文件
   * @param {*} formId 表单id
   * @returns
   */
  async deleteFormDesign(r) {
    return await e.delete(a.DELETE(r));
  },
  // 表单定义导入
  async formDesignImport(r) {
    const t = new FormData();
    return t.append("file", r), await e.post(a.FORM_IMPORT, t);
  },
  /**
   * 表单定义下载
   * @param {string} data  下载的表单定义列表  表单name[]
   */
  async formDesignExport(r, t = "表单定义数据") {
    try {
      n.info(`开始下载${t}...`);
      const s = await e.postDownload(a.FORM_EXPORT, r);
      o.saveAs(s, `${t}.json`);
    } catch (s) {
      n.error(s.msg);
    }
  },
  /**
   * 表单授权角色列表
   * @param {*} formName 表名
   * @returns
   */
  async resourceList(r) {
    return await e.get(a.RESOURCE_LIST(r));
  },
  /**
   * 表单授权角色
   * @param {*} formName 表名
   * @param {*} ids 操作角色id
   * @returns
   */
  async resourceBind(r, t) {
    return await e.post(a.RESOURCE_BIND(r), t);
  },
  /**
   * 表单取消授权角色
   * @param {*} formName 表名
   * @param {*} ids 操作角色id
   * @returns
   */
  async resourceUnbind(r, t) {
    return await e.post(a.RESOURCE_UNBIND(r), t);
  }
};
export {
  p as f
};
